/*
 *
 * Copyright 1998-1999, University of Notre Dame.
 * Authors: Jeffrey M. Squyres, Kinis L. Meyer with M. D. McNally 
 *          and Andrew Lumsdaine
 *
 * This file is part of the Notre Dame LAM implementation of MPI.
 *
 * You should have received a copy of the License Agreement for the
 * Notre Dame LAM implementation of MPI along with the software; see
 * the file LICENSE.  If not, contact Office of Research, University
 * of Notre Dame, Notre Dame, IN 46556.
 *
 * Permission to modify the code and to distribute modified code is
 * granted, provided the text of this NOTICE is retained, a notice that
 * the code was modified is included with the above COPYRIGHT NOTICE and
 * with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
 * file is distributed with the modified code.
 *
 * LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
 * By way of example, but not limitation, Licensor MAKES NO
 * REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
 * PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
 * OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
 * OR OTHER RIGHTS.  
 *
 * Additional copyrights may follow.
 *
 *	Ohio Trollius
 *	Copyright 1993 The Ohio State University
 *	GDB/RBD
 *
 *	$Log: getnet.c,v $
 *	Revision 6.2  1999/05/26 18:29:02  kmeyer1
 *	added copyright
 *	
 *	Revision 6.1  1996/11/24 00:22:51  nevin
 *	Ohio Release
 *	
 * Revision 6.0  96/02/29  14:01:03  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  14:09:59  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:57:22  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:45:49  gdburns
 * Ohio Release
 * 
 * Revision 2.2.1.3  94/02/16  16:27:44  gdburns
 * Move getntype() from getnet.c to getnodes.c
 * 
 * Revision 2.2.1.2  93/10/13  17:09:36  gdburns
 * Remove remote replies.
 * Use KSUPER.
 * 
 * Revision 2.2.1.1  93/02/18  17:54:16  gdburns
 * rewrite in absence of getnet()
 * 
 * Revision 2.2  92/04/30  14:49:40  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/04/27  15:47:49  gdburns
 * Dsend() requires that nmsg be completely filled.
 * 
 * Revision 2.1.1.1  91/06/03  15:08:04  raja
 * Corrected signal masking in ksigblock().
 * 
 * Revision 2.1  91/03/20  11:37:52  gdburns
 * Ohio Release
 * 
 *	Function:	- obtains basic network information
 */

#include <kio.h>
#include <net.h>
#include <rreq.h>

/*
 * external variables
 */
extern struct kio_t	_kio;		/* kernel interface */

/*
 *	getnodeid
 *
 *	Returns:	- local node identifier
 */
int4
getnodeid()

{
	if (_kio.ki_nodeid == NOTNODEID) {
		getnodes(&_kio.ki_nodeid, 1, NT_ME, NT_ME);
	}

	return(_kio.ki_nodeid);
}

/*
 *	getorigin
 *
 *	Returns:	- origin node identifier
 */
int4
getorigin()

{
	if (_kio.ki_origin == NOTNODEID) {
		getnodes(&_kio.ki_origin, 1, NT_ORIGIN, NT_ORIGIN);
	}

	return(_kio.ki_origin);
}

/*
 *	getnodetype
 *
 *	Returns:	- local node type
 */
int4
getnodetype()

{
	return(getrtype(getnodeid()));
}
