/*
 *
 * Copyright 1998-1999, University of Notre Dame.
 * Authors: Jeffrey M. Squyres, Kinis L. Meyer with M. D. McNally 
 *          and Andrew Lumsdaine
 *
 * This file is part of the Notre Dame LAM implementation of MPI.
 *
 * You should have received a copy of the License Agreement for the
 * Notre Dame LAM implementation of MPI along with the software; see
 * the file LICENSE.  If not, contact Office of Research, University
 * of Notre Dame, Notre Dame, IN 46556.
 *
 * Permission to modify the code and to distribute modified code is
 * granted, provided the text of this NOTICE is retained, a notice that
 * the code was modified is included with the above COPYRIGHT NOTICE and
 * with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
 * file is distributed with the modified code.
 *
 * LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
 * By way of example, but not limitation, Licensor MAKES NO
 * REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
 * PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
 * OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
 * OR OTHER RIGHTS.  
 *
 * Additional copyrights may follow.
 *
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	GDB
 *
 *	$Log: rbfsweep1.c,v $
 *	Revision 6.2  1999/05/26 21:50:00  kmeyer1
 *	
 *	added copyright
 *	
 *	Revision 6.1  1996/11/24 00:25:54  nevin
 *	Ohio Release
 *	
 * Revision 6.0  96/02/29  14:04:58  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  14:13:28  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:58:05  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:46:14  gdburns
 * Ohio Release
 * 
 * Revision 2.2  94/02/15  15:24:44  gdburns
 * pre-release to 2.3
 * 
 *	Function:	- removes buffered messages with a particular event
 *	Accepts:	- node ID
 *			- event
 */

#include <net.h>
#include <events.h>
#include <bfreq.h>

int
rbfsweep1(node, event)

int4			node;
int4			event;

{
	struct nmsg	nhead;		/* network header */
	struct bfreq  	*request;	/* bufferd request */

	request = (struct bfreq *) nhead.nh_data;
	request->bfq_req = BFQSWEEP1;
	request->bfq_event = event;

	nhead.nh_node = node;
	nhead.nh_event = EVBUFFERD;
	nhead.nh_type = DLCTL;
	nhead.nh_flags = NOBUF;
	nhead.nh_length = 0;
	nhead.nh_msg = 0;

	return(nsend(&nhead));
}
